<!-- This comment will put IE 6, 7 and 8 in quirks mode -->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>The m17n Library: MInputContext Struct Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javaScript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body onload='searchBox.OnSelectItem(0);'>
<!-- Generated by Doxygen 1.6.3 -->
<script type="text/javascript"><!--
var searchBox = new SearchBox("searchBox", "search",false,'Search');
--></script>
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li class="current"><a href="annotated.html"><span>Data&nbsp;Structures</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <img id="MSearchSelect" src="search/search.png"
             onmouseover="return searchBox.OnSearchSelectShow()"
             onmouseout="return searchBox.OnSearchSelectHide()"
             alt=""/>
        <input type="text" id="MSearchField" value="Search" accesskey="S"
             onfocus="searchBox.OnSearchFieldFocus(true)" 
             onblur="searchBox.OnSearchFieldFocus(false)" 
             onkeyup="searchBox.OnSearchFieldChange(event)"/>
        <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
        </div>
      </li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="annotated.html"><span>Data&nbsp;Structures</span></a></li>
      <li><a href="classes.html"><span>Data&nbsp;Structure&nbsp;Index</span></a></li>
      <li><a href="functions.html"><span>Data&nbsp;Fields</span></a></li>
    </ul>
  </div>
</div>
<div class="contents">
<h1>MInputContext Struct Reference<br/>
<small>
[<a class="el" href="group__m17nInputMethod.html">Input Method (basic)</a>]</small>
</h1><!-- doxytag: class="MInputContext" -->
<p>Structure of input context.  
<a href="#_details">More...</a></p>
<table border="0" cellpadding="0" cellspacing="0">
<tr><td colspan="2"><h2>Data Fields</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="structMInputMethod.html">MInputMethod</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structMInputContext.html#a61a94b70f77af6c5c16111b13c17508d">im</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nMtext.html#gae8bba45315c15c8f79ec4a73ebc52aec">MText</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structMInputContext.html#abcc80db3e3c89a99611e44405540984e">produced</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structMInputContext.html#adaa95c2bfb799d6329bb4e3c2d95b992">arg</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structMInputContext.html#ae9d32f7e51c86e172789ef35d52e36d2">active</a></td></tr>
<tr><td class="memItemLeft" >struct {</td></tr>
<tr><td class="memItemLeft" >&nbsp;&nbsp;&nbsp;int&nbsp;&nbsp;&nbsp;<a class="el" href="structMInputContext.html#ad0ddea81107d27fcea91b833c6cd8c46">x</a></td></tr>
<tr><td class="memItemLeft" >&nbsp;&nbsp;&nbsp;int&nbsp;&nbsp;&nbsp;<a class="el" href="structMInputContext.html#a1bce06fc197b83fbe61ebe0b0d366c94">y</a></td></tr>
<tr><td class="memItemLeft" >&nbsp;&nbsp;&nbsp;int&nbsp;&nbsp;&nbsp;<a class="el" href="structMInputContext.html#ad1203e2d94ecae1faf59b396335746e9">ascent</a></td></tr>
<tr><td class="memItemLeft" >&nbsp;&nbsp;&nbsp;int&nbsp;&nbsp;&nbsp;<a class="el" href="structMInputContext.html#ab1ec923a596b4deb2a1ad086ec26b4f5">descent</a></td></tr>
<tr><td class="memItemLeft" >&nbsp;&nbsp;&nbsp;int&nbsp;&nbsp;&nbsp;<a class="el" href="structMInputContext.html#a5024b6f408bf42851ed351fb042fbe96">fontsize</a></td></tr>
<tr><td class="memItemLeft" >&nbsp;&nbsp;&nbsp;<a class="el" href="group__m17nMtext.html#gae8bba45315c15c8f79ec4a73ebc52aec">MText</a> *&nbsp;&nbsp;&nbsp;<a class="el" href="structMInputContext.html#a8b253a1996d374bcf6d72787bcb9c201">mt</a></td></tr>
<tr><td class="memItemLeft" >&nbsp;&nbsp;&nbsp;int&nbsp;&nbsp;&nbsp;<a class="el" href="structMInputContext.html#a6c3634d77ee1e647c3ffebdcbb6eb0f8">pos</a></td></tr>
<tr><td class="memItemLeft" valign="top">}&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structMInputContext.html#a073747cc1fd3105429f73a89d0c36f9c">spot</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structMInputContext.html#a4da2ca307715dcbeca602aa5cfcb33c1">info</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nMtext.html#gae8bba45315c15c8f79ec4a73ebc52aec">MText</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structMInputContext.html#a8d97006361b9b752d35f00e5ac75b238">status</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structMInputContext.html#a851999b4de16727f39e918bb388deab4">status_changed</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nMtext.html#gae8bba45315c15c8f79ec4a73ebc52aec">MText</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structMInputContext.html#ac21bdea1c1b75147e95f473f9c1f858e">preedit</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structMInputContext.html#a341be05656979fb92e860f4c024ffcb0">preedit_changed</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structMInputContext.html#ac9591f83981bf35ba2f1d3dd434c4874">cursor_pos</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structMInputContext.html#a185a8cda3e382b121b8be90c7833c624">cursor_pos_changed</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nPlist.html#gac8b2ac3c9a8f0a6afb7f189b694035e2">MPlist</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structMInputContext.html#a1e5d075cdade4c6fa85df493b4d59bd8">candidate_list</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structMInputContext.html#a76794f673ced6c5533d70b8402932d7f">candidate_index</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structMInputContext.html#abf2bc304a81d74df89d64c9a18f19cbe">candidate_show</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structMInputContext.html#af22fda4a16e654bba630b093807b78f9">candidates_changed</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nPlist.html#gac8b2ac3c9a8f0a6afb7f189b694035e2">MPlist</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structMInputContext.html#a12f494b6550e5ec675c187766fb9e461">plist</a></td></tr>
<tr><td colspan="2"><div class="groupHeader"></div></td></tr>
<tr><td colspan="2"><div class="groupText"><p><a class="anchor" id="amgrpd41d8cd98f00b204e9800998ecf8427e"></a> </p>
</div></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structMInputContext.html#a943db73e2b3acc93f688ae4906634c33">candidate_from</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="structMInputContext.html#a833ed0b9c6f4143ba5d96565701b9a2d">candidate_to</a></td></tr>
</table>
<hr/><a name="_details"></a><h2>Detailed Description</h2>
<p>Structure of input context. </p>
<p>See struct <a class="el" href="structMInputContext.html" title="Structure of input context.">MInputContext</a>.</p>
<p>The type <code><a class="el" href="structMInputContext.html" title="Structure of input context.">MInputContext</a></code> is the structure of input context objects. </p>
<hr/><h2>Field Documentation</h2>
<a class="anchor" id="a61a94b70f77af6c5c16111b13c17508d"></a><!-- doxytag: member="MInputContext::im" ref="a61a94b70f77af6c5c16111b13c17508d" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="structMInputMethod.html">MInputMethod</a>* <a class="el" href="structMInputContext.html#a61a94b70f77af6c5c16111b13c17508d">MInputContext::im</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>Backward pointer to the input method. It is set up be the function <a class="el" href="group__m17nInputMethod.html#ga8b32df84c645f73ed65e20a1d51c1859" title="Create an input context.">minput_create_ic()</a>. </p>

</div>
</div>
<a class="anchor" id="abcc80db3e3c89a99611e44405540984e"></a><!-- doxytag: member="MInputContext::produced" ref="abcc80db3e3c89a99611e44405540984e" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nMtext.html#gae8bba45315c15c8f79ec4a73ebc52aec">MText</a>* <a class="el" href="structMInputContext.html#abcc80db3e3c89a99611e44405540984e">MInputContext::produced</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>M-text produced by the input method. It is set up by the function <a class="el" href="group__m17nInputMethod.html#gafe533480c705b877189938a0eecb1b57" title="Look up a text produced in the input context.">minput_lookup()</a> . </p>

</div>
</div>
<a class="anchor" id="adaa95c2bfb799d6329bb4e3c2d95b992"></a><!-- doxytag: member="MInputContext::arg" ref="adaa95c2bfb799d6329bb4e3c2d95b992" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="structMInputContext.html#adaa95c2bfb799d6329bb4e3c2d95b992">MInputContext::arg</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>Argument given to the function <a class="el" href="group__m17nInputMethod.html#ga8b32df84c645f73ed65e20a1d51c1859" title="Create an input context.">minput_create_ic()</a>. </p>

</div>
</div>
<a class="anchor" id="ae9d32f7e51c86e172789ef35d52e36d2"></a><!-- doxytag: member="MInputContext::active" ref="ae9d32f7e51c86e172789ef35d52e36d2" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int <a class="el" href="structMInputContext.html#ae9d32f7e51c86e172789ef35d52e36d2">MInputContext::active</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>Flag telling whether the input context is currently active or inactive. The value is set to 1 (active) when the input context is created. It is toggled by the function <a class="el" href="group__m17nInputMethod.html#ga065a8f8e5a28180fd0fa6d160e07481b" title="Toggle input method.">minput_toggle()</a>. </p>

</div>
</div>
<a class="anchor" id="ad0ddea81107d27fcea91b833c6cd8c46"></a><!-- doxytag: member="MInputContext::x" ref="ad0ddea81107d27fcea91b833c6cd8c46" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int <a class="el" href="structMInputContext.html#ad0ddea81107d27fcea91b833c6cd8c46">MInputContext::x</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>X and Y coordinate of the spot. </p>

</div>
</div>
<a class="anchor" id="a1bce06fc197b83fbe61ebe0b0d366c94"></a><!-- doxytag: member="MInputContext::y" ref="a1bce06fc197b83fbe61ebe0b0d366c94" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int <a class="el" href="structMInputContext.html#a1bce06fc197b83fbe61ebe0b0d366c94">MInputContext::y</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

</div>
</div>
<a class="anchor" id="ad1203e2d94ecae1faf59b396335746e9"></a><!-- doxytag: member="MInputContext::ascent" ref="ad1203e2d94ecae1faf59b396335746e9" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int <a class="el" href="structMInputContext.html#ad1203e2d94ecae1faf59b396335746e9">MInputContext::ascent</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>Ascent and descent pixels of the line of the spot. </p>

</div>
</div>
<a class="anchor" id="ab1ec923a596b4deb2a1ad086ec26b4f5"></a><!-- doxytag: member="MInputContext::descent" ref="ab1ec923a596b4deb2a1ad086ec26b4f5" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int <a class="el" href="structMInputContext.html#ab1ec923a596b4deb2a1ad086ec26b4f5">MInputContext::descent</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

</div>
</div>
<a class="anchor" id="a5024b6f408bf42851ed351fb042fbe96"></a><!-- doxytag: member="MInputContext::fontsize" ref="a5024b6f408bf42851ed351fb042fbe96" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int <a class="el" href="structMInputContext.html#a5024b6f408bf42851ed351fb042fbe96">MInputContext::fontsize</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>Font size for preedit text in 1/10 point. </p>

</div>
</div>
<a class="anchor" id="a8b253a1996d374bcf6d72787bcb9c201"></a><!-- doxytag: member="MInputContext::mt" ref="a8b253a1996d374bcf6d72787bcb9c201" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nMtext.html#gae8bba45315c15c8f79ec4a73ebc52aec">MText</a>* <a class="el" href="structMInputContext.html#a8b253a1996d374bcf6d72787bcb9c201">MInputContext::mt</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>M-text at the spot, or NULL. </p>

</div>
</div>
<a class="anchor" id="a6c3634d77ee1e647c3ffebdcbb6eb0f8"></a><!-- doxytag: member="MInputContext::pos" ref="a6c3634d77ee1e647c3ffebdcbb6eb0f8" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int <a class="el" href="structMInputContext.html#a6c3634d77ee1e647c3ffebdcbb6eb0f8">MInputContext::pos</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>Character position in &lt;mt&gt; at the spot. </p>

</div>
</div>
<a class="anchor" id="a073747cc1fd3105429f73a89d0c36f9c"></a><!-- doxytag: member="MInputContext::spot" ref="a073747cc1fd3105429f73a89d0c36f9c" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">struct { ... }   <a class="el" href="structMInputContext.html#a073747cc1fd3105429f73a89d0c36f9c">MInputContext::spot</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>Spot location and size of the input context. </p>

</div>
</div>
<a class="anchor" id="a4da2ca307715dcbeca602aa5cfcb33c1"></a><!-- doxytag: member="MInputContext::info" ref="a4da2ca307715dcbeca602aa5cfcb33c1" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="structMInputContext.html#a4da2ca307715dcbeca602aa5cfcb33c1">MInputContext::info</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>The usage of the following members depends on the input method driver. The descriptions below are for the driver of an internal input method. They are set by the function &lt;im&gt;-&gt;driver.filter(). Pointer to extra information that &lt;im&gt;-&gt;driver.create_ic() setups. It is used to record the internal state of the input context. </p>

</div>
</div>
<a class="anchor" id="a8d97006361b9b752d35f00e5ac75b238"></a><!-- doxytag: member="MInputContext::status" ref="a8d97006361b9b752d35f00e5ac75b238" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nMtext.html#gae8bba45315c15c8f79ec4a73ebc52aec">MText</a>* <a class="el" href="structMInputContext.html#a8d97006361b9b752d35f00e5ac75b238">MInputContext::status</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>M-text describing the current status of the input context. </p>

</div>
</div>
<a class="anchor" id="a851999b4de16727f39e918bb388deab4"></a><!-- doxytag: member="MInputContext::status_changed" ref="a851999b4de16727f39e918bb388deab4" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int <a class="el" href="structMInputContext.html#a851999b4de16727f39e918bb388deab4">MInputContext::status_changed</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>The function &lt;im&gt;-&gt;driver.filter() sets the value to 1 when it changes &lt;status&gt;. </p>

</div>
</div>
<a class="anchor" id="ac21bdea1c1b75147e95f473f9c1f858e"></a><!-- doxytag: member="MInputContext::preedit" ref="ac21bdea1c1b75147e95f473f9c1f858e" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nMtext.html#gae8bba45315c15c8f79ec4a73ebc52aec">MText</a>* <a class="el" href="structMInputContext.html#ac21bdea1c1b75147e95f473f9c1f858e">MInputContext::preedit</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>M-text containing the current preedit text. The function &lt;im&gt;-&gt;driver.filter() sets the value. </p>

</div>
</div>
<a class="anchor" id="a341be05656979fb92e860f4c024ffcb0"></a><!-- doxytag: member="MInputContext::preedit_changed" ref="a341be05656979fb92e860f4c024ffcb0" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int <a class="el" href="structMInputContext.html#a341be05656979fb92e860f4c024ffcb0">MInputContext::preedit_changed</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>The function &lt;im&gt;-&gt;driver.filter() sets the value to 1 when it changes &lt;preedit&gt;. </p>

</div>
</div>
<a class="anchor" id="ac9591f83981bf35ba2f1d3dd434c4874"></a><!-- doxytag: member="MInputContext::cursor_pos" ref="ac9591f83981bf35ba2f1d3dd434c4874" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int <a class="el" href="structMInputContext.html#ac9591f83981bf35ba2f1d3dd434c4874">MInputContext::cursor_pos</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>Cursor position of &lt;preedit&gt;. </p>

</div>
</div>
<a class="anchor" id="a185a8cda3e382b121b8be90c7833c624"></a><!-- doxytag: member="MInputContext::cursor_pos_changed" ref="a185a8cda3e382b121b8be90c7833c624" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int <a class="el" href="structMInputContext.html#a185a8cda3e382b121b8be90c7833c624">MInputContext::cursor_pos_changed</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>The function &lt;im&gt;-&gt;driver.filter() sets the value to 1 when it changes &lt;cursor_pos&gt;. </p>

</div>
</div>
<a class="anchor" id="a1e5d075cdade4c6fa85df493b4d59bd8"></a><!-- doxytag: member="MInputContext::candidate_list" ref="a1e5d075cdade4c6fa85df493b4d59bd8" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nPlist.html#gac8b2ac3c9a8f0a6afb7f189b694035e2">MPlist</a>* <a class="el" href="structMInputContext.html#a1e5d075cdade4c6fa85df493b4d59bd8">MInputContext::candidate_list</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>Plist of the current candidate groups. Each element is an M-text or a plist. If an element is an M-text (i.e. the key is Mtext), candidates in that group are characters in the M-text. If it is a plist (i.e. the key is Mplist), each element is an M-text, and candidates in that group are those M-texts. </p>

</div>
</div>
<a class="anchor" id="a76794f673ced6c5533d70b8402932d7f"></a><!-- doxytag: member="MInputContext::candidate_index" ref="a76794f673ced6c5533d70b8402932d7f" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int <a class="el" href="structMInputContext.html#a76794f673ced6c5533d70b8402932d7f">MInputContext::candidate_index</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>Index number of the currently selected candidate in all the candidates. The index of the first candidate is 0. If the number is 8, and the first candidate group contains 7 candidates, the currently selected candidate is the second element of the second candidate group. </p>

</div>
</div>
<a class="anchor" id="a943db73e2b3acc93f688ae4906634c33"></a><!-- doxytag: member="MInputContext::candidate_from" ref="a943db73e2b3acc93f688ae4906634c33" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int <a class="el" href="structMInputContext.html#a943db73e2b3acc93f688ae4906634c33">MInputContext::candidate_from</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>Start and the end positions of the preedit text where &lt;candidate_list&gt; corresponds to. </p>

</div>
</div>
<a class="anchor" id="a833ed0b9c6f4143ba5d96565701b9a2d"></a><!-- doxytag: member="MInputContext::candidate_to" ref="a833ed0b9c6f4143ba5d96565701b9a2d" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int <a class="el" href="structMInputContext.html#a833ed0b9c6f4143ba5d96565701b9a2d">MInputContext::candidate_to</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

</div>
</div>
<a class="anchor" id="abf2bc304a81d74df89d64c9a18f19cbe"></a><!-- doxytag: member="MInputContext::candidate_show" ref="abf2bc304a81d74df89d64c9a18f19cbe" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int <a class="el" href="structMInputContext.html#abf2bc304a81d74df89d64c9a18f19cbe">MInputContext::candidate_show</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>Flag telling whether the current candidate group must be shown or not. The function &lt;im&gt;-&gt;driver.filter() sets the value to 1 when an input method required to show candidates, and sets the value to 0 otherwise. </p>

</div>
</div>
<a class="anchor" id="af22fda4a16e654bba630b093807b78f9"></a><!-- doxytag: member="MInputContext::candidates_changed" ref="af22fda4a16e654bba630b093807b78f9" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int <a class="el" href="structMInputContext.html#af22fda4a16e654bba630b093807b78f9">MInputContext::candidates_changed</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>The function &lt;im&gt;-&gt;driver.filter() sets the value to bitwise OR of <code>enum</code> <code>MInputCandidatesChanged</code> when it changed any of the above members (&lt;candidate_XXX&gt;), and sets the value to 0 otherwise. </p>

</div>
</div>
<a class="anchor" id="a12f494b6550e5ec675c187766fb9e461"></a><!-- doxytag: member="MInputContext::plist" ref="a12f494b6550e5ec675c187766fb9e461" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nPlist.html#gac8b2ac3c9a8f0a6afb7f189b694035e2">MPlist</a>* <a class="el" href="structMInputContext.html#a12f494b6550e5ec675c187766fb9e461">MInputContext::plist</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>Plist that can be freely used by &lt;im&gt;-&gt;driver functions. The driver of internal input method uses it to exchange extra arguments and result for callback functions. The function &lt;im&gt;-&gt;driver.create_ic() sets this to an empty plist, and the function &lt;im&gt;-&gt;driver.destroy_ic() frees it by using <a class="el" href="group__m17nObject.html#ga248ba287a615a2cf3cdb99c13275453b" title="Decrement the reference count of a managed object.">m17n_object_unref()</a>. </p>

</div>
</div>
</div>
<!--- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&nbsp;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&nbsp;</span>Data Structures</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&nbsp;</span>Files</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&nbsp;</span>Functions</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&nbsp;</span>Variables</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(5)"><span class="SelectionMark">&nbsp;</span>Typedefs</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(6)"><span class="SelectionMark">&nbsp;</span>Enumerations</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(7)"><span class="SelectionMark">&nbsp;</span>Enumerator</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(8)"><span class="SelectionMark">&nbsp;</span>Defines</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<hr>

<ADDRESS>
<a href="http://www.m17n.org/m17n-lib-en/index.html" target="mulewindow"><img src="parrot.png" align=bottom alt="m17n-lib Home" border=0></a>
</ADDRESS>
</body>
</HTML>

<!-- Copyright information

Copyright (C) 2001 Information-technology Promotion Agency (IPA)
Copyright (C) 2001-2011
  National Institute of Advanced Industrial Science and Technology (AIST)

This file is part of the m17n library documentation.

Permission is granted to copy, distribute and/or modify this document
under the terms of the GNU Free Documentation License, Version 1.2 or
any later version published by the Free Software Foundation; with no
Invariant Section, no Front-Cover Texts,
and no Back-Cover Texts.  A copy of the license is included in the
appendix entitled "GNU Free Documentation License".
-->
